//
// Copyright (C) 1999, 2000 Lyle Coder (x_coder@hotmail.com)
//
// RIM mpak code by Chris Faherty
// Copyright (C) 2000 Chris Faherty <rallymonkey@bellsouth.net>
//
#include <string.h>
#include "int_message.h"
#include "message.h"
#include "database.h"
#include "radio.h"
#include "mobitex.h"
#include "UI32.h"
#include "pager.h"
#include "msg_api.h"
#include "OKDialog.h"
#include "WAP.h"
#include "Tag.h"
#include "TagField.h"
#include "expat/xmlparse/xmlparse.h"

#define TEST_WML_BBC \
 "<wml>\r" \
 "<card>\r" \
 "<p align=\"center\"><img alt=\"BBC\" src=\"bbcmono.wbmp\" align=\"bottom\" vspace=\"0\" hspace=\"0\"/></p>\r" \
 "<p>\r" \
 "<a title=\"News\" href=\"newsheads1.wml\">News</a><br/>\r" \
 "<a title=\"Sport\" href=\"sportheads1.wml\">Sport</a><br/>\r" \
 "<a title=\"Weather\" href=\"weatherheads1.wml\">Weather</a><br/>\r" \
 "<a title=\"TV\" href=\"tvheads1.wml\">TV</a><br/>\r" \
 "<a title=\"Showbiz\" href=\"showbizheads1.wml\">Showbiz</a><br/>\r" \
 "<a title=\"City\" href=\"cityheads1.wml\">City</a><br/>\r" \
 "<a title=\"Sci-tech\" href=\"sci-techheads1.wml\">Sci-tech</a><br/>\r" \
 "<a title=\"Travel\" href=\"travelheads1.wml\">Travel</a><br/>\r" \
 "<br/>\r" \
 "<b>This is a trial service from BBC NewsIf the compiler generated this instruction, then the compiler is at fault. However, it looks like you are compiling a hand-written assembly file, because the filename in the error message ends in .S.  The only way that can happen is if you feed an assembly file to the compiler.  In this case, the error would be in the hand-written assembly language code.</b>\r" \
 "</p>\r" \
 "</card>\r" \
 "</wml>\r"

#define TEST_WML_CNN \
 "<wml xml:lang=\"en-us\">" \
 "<card><p>" \
 "&quot;Skip to main content&quot;" \
 "<br/>" \
 "<a href=\"http://63.197.4.216:8080/proxy?http://www.cnn.com/event.ng/Type=click=11075=469=15649=335=1217=4.8.435.606.644.645=http:%2F%2Fwww.cnn.com%2FWEATHER\" title=\"/event.ng/Type=click=11075=469=15649=335=1217=4.8.435.606.644.645=http:%2F%2Fwww.cnn.com%2FWEATHER\">" \
 "(img)" \
 "</a>" \
 "<br/>" \
 "<a href=\"http://63.197.4.216:8080/proxy?http://www.cnn.com/event.ng/Type=click=11075=469=15649=335=1217=4.8.435.606.644.645=http:%2F%2Fwww.cnn.com%2FWEATHER\" title=\"/event.ng/Type=click=11075=469=15649=335=1217=4.8.435.606.644.645=http:%2F%2Fwww.cnn.com%2FWEATHER\">" \
 "Click Here" \
 "</a>" \
 "<br/>" \
 "&quot;ad info&quot;" \
 "<br/>" \
 "<a href=\"http://63.197.4.216:8080/proxy?http://www.cnn.com/event.ng/Type=click=24134=51=21711=20=4324=4.8.305.435.594=http:%2F%2Fwww.buyandhold.com%2FBuy%3Frequest%3Drr.refBy%26ref%3DCNN%26dest%3D%2Findex.html\" title=\"/event.ng/Type=click=24134=51=21711=20=4324=4.8.305.435.594=http:%2F%2Fwww.buyandhold.com%2FBuy%3Frequest%3Drr.refBy%26ref%3DCNN%26dest%3D%2Findex.html\">" \
 "(img)" \
 "</a>" \
 "<br/>" \
 "<br/><a title=\"Next Page\" href=\"http://63.197.4.216:8080/stream?index=0+pos=1191\">Next Page...</a>" \
 "</p></card>" \
 "</wml>"

//
// According to Chris, this is where the pager stores it's messages... there _has_ to be a better
// way to get at the messages!
//
MessageDatabase message_database("msg.db", "msgf.db");

int BrowserScreen::HandleMenu()
{
    RESULT result;

    //Display the menu on the screen
    m_uiEngine.ProcessMenu (m_menu);

    for( ; ; ) 
	{
        //Get the next message for this task
        MESSAGE msg;
        RimGetMessage(&msg);

        // If it is a keyboard event, pass it to the UIEngine object
        // to handle.
	    if(msg.Device == DEVICE_KEYPAD) 
		{
		    result = m_uiEngine.HandleInput(msg);

            if(result == CLICKED) 
			{
                // If the user clicked or pressed enter,
                // return the index of the selected item.
                m_uiEngine.ClearMenu ();
                return m_menu.GetSelectedIndex();

            } 
			else if((result == UNHANDLED) || (result == HIDE_MENU) || (result == UI_SWITCH_TO_BACKGROUND)) 
			{
                // If the user pressed backspace, return -1.
                m_uiEngine.ClearMenu();
                return (-1);
            }
        }
    }
}

void BrowserScreen::Display()
{
	char message[128];
	Separator separator(NULL, -1, LCD_LEFT_JUSTIFIED);

	AddField(separator);

	RadioRegister ();

    // Start by displaying the screen.
    m_uiEngine.ProcessScreen(*this);

    while(true) {
        // Get the next message for this task
        MESSAGE msg;
        RimGetMessage(&msg);
        switch(msg.Device) {
            case DEVICE_KEYPAD:
			{
				RESULT result = m_uiEngine.HandleInput(msg);
				switch(result) {
					case CLICKED:
					{
						// The user clicked, so bring up the menu
						int index = HandleMenu();

						switch(index) {
							case GO:
							{
#if 0
								char content[2048];
								strcpy(content, TEST_WML_CNN);
								char *tmp = find((char *)content, "</wml>");
								//
								// Remove old content
								//
								if(current) {
									Delete(current);
									delete current;
									current = 0;
									active = 0;
								}

								//
								// Parse the wml content
								//
								Parse(content);

								//
								// Walk the Tag tree and show the content
								//
								Print(current);
#else
								DbFieldHandle MsgHandle;
								create_message(NULL);
								char* url = (char *)m_url.GetBuffer();
								if(!strlen(url)) {
									OKDialog okDialog("Enter a URL");
									okDialog.Go(m_uiEngine);
									continue;
								}
								RimSprintf(message, sizeof(message), "<GET>wmlproxy?u=http://%s</GET>", url);
								MsgHandle = add_field_text(MESSAGE_FIELD_TAG, message, strlen(message));
								MsgHandle = add_recipient(TO_FIELD_TAG, EMAIL, "html2wml@yourisp.com", "html2wml@yourisp.com");
   
								//
								// Send the HTTP request via e-mail!
								//
								if(send_message(false)) {
									continue;
								} else {
									OKDialog okDialog("Could not connect to html2wml@yourisp.com");
									okDialog.Go(m_uiEngine);
									continue;
								}
#endif
								break;
							}
							case FOLLOW_LINK:
							{
								if(!active) {
									break;
								}

								DbFieldHandle MsgHandle;
								create_message(NULL);
    
								char* link = 0;
								for(Tag::Attribute *a = active->attrib; a; a = a->next) {
									if(!strncasecmp(a->name, "href", 4)) {
										link = a->param;
										OKDialog okDialog(link);
										okDialog.Go(m_uiEngine);
										break;
									}
								}

								//
								// Could not find an href attribute...
								//
								if(!link) {
									break;
								}

								//
								// XXX This needs to be changes so it does not assume the base server
								//
								char *url = find(link, "/wmlproxy?");
								if(url) {
									url += 1;
								} else {
									continue;
								}
								RimSprintf(message, sizeof(message), "<GET>%s</GET>", url);
								MsgHandle = add_field_text(MESSAGE_FIELD_TAG, message, strlen(message));
								MsgHandle = add_recipient(TO_FIELD_TAG, EMAIL, "html2wml@yourisp.com", "html2wml@yourisp.com");
   
								//
								// Send the HTTP request via e-mail!
								//
								if(send_message(false)) {
									continue;
								} else {
									OKDialog okDialog("Could not connect to html2wml@yourisp.com");
									okDialog.Go(m_uiEngine);
									continue;
								}
								break;
							}
						}
					}
				}
				m_uiEngine.ProcessScreen(*this);
				break;
			}
			case DEVICE_RADIO:
				if(msg.Event == MESSAGE_RECEIVED) {
					MPAK_HEADER hdr;
					unsigned char buffer[MAX_MPAK_DATA_SIZE + 1];
					int len = RadioGetMpak(msg.SubMsg, &hdr, (unsigned char *)buffer);
					// if ((hdr.MpakType == MPAK_HPDATA) && (hdr.HPID == 98) && (len > 8)) {
					if(buffer[0] == 1) {
						//
						// Even though mpaks may arrive out of order, we still
						// assume that a completed message is received before
						// parts of another arrive.
						//
						unsigned int id = (buffer[2] << 8) + buffer[3];
						int num = message_database.get_num_records();
						if (num < 0) {
							break;
						}

						//
						// find the nth record
						//
						DbRecordHandle mh = message_database.get_first_record();
						for(int i = 1; (i < num) && (mh != DB_NULL_HANDLE); i++) {
							mh = message_database.get_next_record(mh);
						}

						if (mh == DB_NULL_HANDLE) {
							break;
						}

						Message message(mh);

						char *body = NULL;

						message.get_body(&body);
						if(body && (strlen(body) > 32)) {
							char mail[2048];
							memset(mail, 0, sizeof(mail));
							strcpy(mail, body);

							//
							// Find WML content if any... could be some other e-mail
							//
							char *wml = find(mail, "<wml");

							if(wml)
							{
								char *end = find(wml, "</wml>");
								if(end)
								{
									*(end + 7) = '\0';
									RimAlertNotify(TONE_SEQUENCE_1, 4);
					
									//
									// Remove old content
									//
									if(current) {
										Delete(current);
										delete current;
										current = 0;
										active = 0;
									}

									//
									// Parse the wml content
									//
									Parse(wml);

									//
									// Walk the Tag tree and show the content
									//
									Print(current);
									m_uiEngine.ProcessScreen(*this);
								}
							}
						}
					}
				}
				break;
		}
    }
}

//
// expat is C... so the following callbacks are in C
//

void start_element(void *user_data, const char *name, const char **attr)
{
	BrowserScreen *browser = (BrowserScreen *)user_data;
	Tag *tag = new Tag((char *)name);

	for(int i = 0; attr[i] && attr[i+1]; i += 2) {
		tag->addAttribute((char *)attr[i], (char *)attr[i+1]);
	}

	if(browser->current) {
		browser->current = browser->current->addChild(tag);
	} else {
		browser->current = tag;
	}
}

void end_element(void *user_data, const char *name)
{
	BrowserScreen *browser = (BrowserScreen *)user_data;
	Tag *tag = browser->current->endTag();
	if(tag) {
		//
		// Prevent current from becomming NULL at the end of the document!!!
		//
		browser->current = tag;
	}
}

void data_element(void *user_data, const char *str, int len)
{
	if(len && ((*str == '\n') || (*str == '\r'))) {
		return;
	}
	BrowserScreen *browser = (BrowserScreen *)user_data;
	browser->current->addData((char *)str, len);
}

void BrowserScreen::Parse(char *wml)
{
	XML_Parser parser = XML_ParserCreate(0);
	XML_SetUserData(parser, this);
	XML_SetElementHandler(parser, start_element, end_element);
	XML_SetCharacterDataHandler(parser, data_element);

	if(!XML_Parse(parser, wml, strlen(wml), 1)) {
		RimSprintf(error, sizeof(error), "%s:%d", XML_ErrorString(XML_GetErrorCode(parser)), XML_GetCurrentLineNumber(parser));
		OKDialog okDialog(error);
		okDialog.Go(m_uiEngine);
	}

	//
	// Don't need the parser anymore
	//
	XML_ParserFree(parser);
}

void BrowserScreen::Delete(Tag *root) 
{
	if(root->getUserData()) {
		RemoveField(*(TagField *)root->getUserData());
		delete (TagField *)root->getUserData();
		root->setUserData(0);
	}

	if(root->child) {
		Delete(root->child);
	}

	if(root->sibling) {
		Delete(root->sibling);
	}
}

void BrowserScreen::Print(Tag *root)
{
	//
	// First display any data in the current node
	//
	if(root->data) {
		//
		// What we could really use here is a Text Field
		//

		TagField *tag = new TagField(this, root, (char * const)(root->data), strlen(root->data) + 1, 0, LCD_LEFT_JUSTIFIED);
		tag->SetProperties(Edit::READ_ONLY, 0);
		AddField(*tag, NULL);
		root->setUserData(tag);
	}

	if(root->child) {
		Print(root->child);
	}

	if(root->sibling) {
		Print(root->sibling);
	}
}
