//
// Copyright (C) 1999, 2000 Lyle Coder (x_coder@hotmail.com)
//

#ifndef _STRINGFIELD_H_
#define _STRINGFIELD_H_

#include "UI32.h"
#include <string.h>

class StringField : public Field 
{

public:
	StringField(char *str) : focus(false), line(0)
	{
		data = str;   
	}

	void ResetDimensionDependentData()
	{
	}

	int QueryPixelHeight(FieldLocation const StartFrom, int const MaximumRelevant)
	{
		return 30;
	}

	int QueryHeightInArea(FieldLocation const StartFrom )
	{
		return 40;
	}

	int QueryLineHeight(int const MaximumRelevant)
	{
		return 1;
	}

	bool IsFocusVisible()
	{
		return focus;
	}

	void Redraw()
	{
		LcdPutStringXY(0, 30, data, strlen(data), TEXT_NORMAL | LCD_LEFT_JUSTIFIED | LCD_MULTILINE);
	}

	void Draw(int const PixelOnScreen, FieldLocation const AnchoredFrom, int &TopPixel, int &HeightinPixels, bool &MoreDataAtTop, bool &MoreDataAtBottom)
	{
		LcdPutStringXY(0, 30, data, strlen(data), TEXT_NORMAL | LCD_LEFT_JUSTIFIED | LCD_MULTILINE);
		TopPixel = 30;
		HeightinPixels = 30;
		MoreDataAtTop = false;
		MoreDataAtBottom = false;
	}

	void UnDraw()
	{
		LcdPutStringXY(0, 30, data, strlen(data), TEXT_BLANK | LCD_LEFT_JUSTIFIED | LCD_MULTILINE);
	}

	bool GiveFocus(int const DirectionMagnitude)
	{
		focus = true;
		return true;
	}

	void TakeFocus()
	{
		focus = false;
	}

	RESULT HandleInput(MESSAGE const &InputMessage)
	{
		return CONTINUE;
	}

	FIELDTYPE GetFieldType(FIELDTYPE * pDerived)
	{
		return NULL_FIELD;
	}

protected:
	bool focus;
	char *data;
	int line;
};

#endif
