/***************************************************************************
 ClickDialog.h

 Description:
    A dialog box that is dismissed when the user clicks the thumb wheel.

 Copyright (C) 1997-1999 Research In Motion Limited
 ***************************************************************************/

#ifndef clickdialog_h_included
#define clickdialog_h_included


#ifdef DLLAccess
#undef DLLAccess
#endif

#ifdef _UI_
#define DLLAccess DLLExport
#else
#define DLLAccess DLLImport
#endif

#include "UI32.h"
#include "warning.h"


class DLLAccess ClickDialog: public Dialog
{
    public: // used by client


        ClickDialog();
        ClickDialog( char const * const newpDisplayString, 
                     BitMap const * const newpBitmap=NULL );
        ClickDialog( char const * const newpDisplayString,
                     Bitmaps::PREDEFINED_BITMAP const PredefinedBitmap );
        
        //Handles the input passed in by the UI Engine
        RESULT  HandleInput(MESSAGE const &InputMessage);

        void DisplayDialog();
		


};

#endif //clickdialog_h_included
