/*-------------------------------------------------------------------------*
 *
 * Comm.h
 *  This file defines the serial API.
 *
 * Copyright 1997-1998 Research In Motion Limited.  All Rights Reserved
 *-------------------------------------------------------------------------*/

#ifndef __COMM_H
#define __COMM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "BaseType.h"


/*-------------------------------------------------------------------------*
 * Constants.
 *-------------------------------------------------------------------------*/

/* COMM events. */
#define COMM_CONTROL_CHANGE     0x0501
#define COMM_RX_ERROR           0x0502
#define COMM_RX_AVAILABLE       0x0503
#define COMM_TX_EMPTY           0x0504
#define COMM_PATTERN_NOTIFY     0x0506

/* Device settings. */
#define COMM_NO_PARITY          0
#define COMM_EVEN_PARITY        1
#define COMM_ODD_PARITY         2

/* Error codes. */
#define COMM_ERROR_NOT_OPEN     1
#define COMM_ERROR_PARITY       2
#define COMM_ERROR_FRAMING      3
#define COMM_ERROR_OVERRUN      4


/*-------------------------------------------------------------------------*
 * Function Prototypes.
 *-------------------------------------------------------------------------*/

void    __cdecl CommRegisterNotifyPattern(void * NotifyPattern);
int     __cdecl CommOpenPort(DWORD Baud, int Databits, int Parity, int Stopbits, int RxBufferSize, int TxBufferSize);
void    __cdecl CommClosePort(void);
int     __cdecl CommSendBuffer(void * Data, int Length);
int     __cdecl CommSendChar(BYTE Character);
int     __cdecl CommReadBuffer(void * Data, int Length);
int     __cdecl CommReadChar(void);
void    __cdecl CommSettings(DWORD Baud, int Databits, int Parity, int Stopbits);
void    __cdecl CommSetDsr(int State);
int     __cdecl CommGetDtr(void);
int     __cdecl CommTxCount(void);
void    __cdecl CommStandbyMode(BOOL State);

#ifdef __cplusplus
}
#endif

#endif  /* __COMM_H */
