/****************************************************************************
 linkedlist.h  -  declares an interface for a linked list 
 
 Description:
     Contains the LinkedListEntry Class which should be a base class for
		the objects that are going to be linked.
	 Contains the LinkedListClass which collects the list entries
 
 Copyright (C) 1997-1998 Research In Motion Limited
 ***************************************************************************/

#ifndef linkedlist_h_included
#define linkedlist_h_included

#include "warning.h"

class LinkedListEntry;
class LinkedList;


class DLLExport LinkedListEntry
{
	public:
        LinkedListEntry();

    
		//Doubly linked list interface
		void InsertAfter( LinkedListEntry * pLinkedListEntry ); //adds element after the current element
		void InsertBefore( LinkedListEntry * pLinkedListEntry ); //adds element after the current element
		virtual LinkedListEntry * Remove(); //returns pointer to element removed
    
		virtual LinkedListEntry * Next();
		virtual LinkedListEntry * Prev();
    
	protected:
   
  
		//for linking elements together
		LinkedListEntry * pNext; //Next and previous Elements of the screen, NULL for head or tail
		LinkedListEntry * pPrev; 
 

};



class DLLExport LinkedList
{
	public:
        LinkedList();
		void InsertAfter( LinkedListEntry * pLinkedListEntrytoInsert, 
                          LinkedListEntry * pEntrytoInsertAfter );
		void InsertBefore( LinkedListEntry * pLinkedListEntrytoInsert, 
                           LinkedListEntry * pEntrytoInsertBefore );
		LinkedListEntry * GetFirst();
        LinkedListEntry * GetLast();
		LinkedListEntry * GetNext( LinkedListEntry * pLinkedListEntrytoInsert );
        LinkedListEntry * GetPrev( LinkedListEntry * pSelected );
		LinkedListEntry * Remove( LinkedListEntry * pLinkedListEntrytoRemove );
		void RemoveAll();


	private:

		LinkedListEntry * pHead;
		LinkedListEntry * pTail;

};



      
#endif // linkedlist_h_included
