/*
 * storage.h
 */


#ifndef STORAGE_H
#define STORAGE_H


#include "pager.h"
#include "utilities.h"



class PersistentStore
{
   private:
      
      HandleType db_database_handle;
      HandleType db_record_handle;
      
   
   public:
   
      PersistentStore( char * filename )
         : db_database_handle( DbGetHandle( filename ) )
         , db_record_handle( DbFirstRec( db_database_handle ) )
      {
         }
         
         
      bool 
      load_data( void * data_ptr,
                 int data_length );


      bool
      save_data( void * data_ptr,
                 int data_length );


      void
      zero_data( void );

   };





#endif
