/*-------------------------------------------------------------------------*
 *
 * KeyPad.h
 *  This file defines the keypad API.
 *
 * Copyright 1997-1998 Research In Motion Limited.  All Rights Reserved
 *-------------------------------------------------------------------------*/

#ifndef __KEYPAD_H
#define __KEYPAD_H

#ifdef __cplusplus
extern "C" {
#endif

#include "BaseType.h"


/*-------------------------------------------------------------------------*
 * Constants.
 *-------------------------------------------------------------------------*/

/* KEYPAD events. */
#define KEY_DOWN                0x0201
#define KEY_REPEAT              0x0202
#define KEY_UP                  0x0203
#define THUMB_CLICK             0x0204
#define THUMB_UNCLICK           0x0205
#define THUMB_ROLL_UP           0x0206
#define THUMB_ROLL_DOWN         0x0207
#define KEY_STATUS              0x0208

/* Additional KEYPAD information. */
#define ALT_STATUS              0x0001
#define SHIFT_STATUS            0x0002
#define CAPS_LOCK               0x0004
#define KEY_HELD_WHILE_ROLLING  0x0008

#define KEY_BACKSPACE           0x08
#define KEY_ENTER               0x0d
#define KEY_SPACE               0x20
#define KEY_DELETE              0x7f

#define KEY_SHIFT               256
#define KEY_ALT                 257     // The yellow key


/*-------------------------------------------------------------------------*
 * Function Prototypes.
 *-------------------------------------------------------------------------*/

void    __cdecl KeypadBeep( BOOL Enable );
void    __cdecl KeypadRate( WORD Delay, WORD Rate );
BOOL    __cdecl KeypadRegister( DWORD Key );


#ifdef __cplusplus
}
#endif

#endif  /* __KEYPAD_H */
