/****************************************************************************
 OKDialog.h
 
 Description:
    An OKDialog is a rectangular dialog box that contains a text string and
    the text "Ok".  The dialog will not be dismissed until the user highlights
    "Ok" and clicks the thumb wheel.

 Copyright (C) 1997-1999 Research In Motion Limited
 ***************************************************************************/

#ifndef okdialog_h_included
#define okdialog_h_included


#ifdef DLLAccess
#undef DLLAccess
#endif

#ifdef _UI_
#define DLLAccess DLLExport
#else
#define DLLAccess DLLImport
#endif

#include "ui32.h"
#include "warning.h"

#pragma data_seg( ".text" )
char const * const OKChoices[ 2 ] = {"Ok", NULL };
#pragma data_seg()

class DLLAccess OKDialog: public Dialog
{
    public: // used by client

        OKDialog( char const * const pStatement = NULL );

        //Displays the dialog and returns ITEM_CANCEL
        virtual RESULT Go( UIEngine &UIEngineToUse );

        //Handles the input passed in by the UI Engine
		RESULT  HandleInput( MESSAGE const &InputMessage );

        //Set the text string to be used for the question
        bool SetQuestion( char const * const pStatement )
        {
            m_pStatement = pStatement;
            return true;
        }
		
    protected:

        char const * m_pStatement;
        StringList   m_StringList;

};

#endif // okdialog_h_included
