/*-------------------------------------------------------------------------*
 *
 * Pager.h
 * This file must be included by ALL Pager application source files.
 *
 * Copyright 1997-1998 Research In Motion Limited.  All Rights Reserved
 *-------------------------------------------------------------------------*/

#ifndef __PAGER_H
#define __PAGER_H

#if _MSC_VER >= 1100            // Only works in MSDEV 5.0
    #pragma const_seg(".text")  // Put all constants in ROM section
#endif

#ifdef __cplusplus
extern "C" {
#endif


/*
 * The OS Version.
 */
#define OS_VERSION      1
#define OS_REVISION     4
#define OS_RELEASE     57
#define OS_BUILD        0

#define OS_API_VERSION  ((OS_VERSION << 24) | (OS_REVISION << 16) | (OS_RELEASE << 8) | OS_BUILD)


/*-------------------------------------------------------------------------*
 * Generic Types
 *-------------------------------------------------------------------------*/
#include "BaseType.h"

/*-------------------------------------------------------------------------*
 * General OS Routines
 *-------------------------------------------------------------------------*/
#include "Rim.h"

/*-------------------------------------------------------------------------*
 * LCD Routines
 *-------------------------------------------------------------------------*/
#include "LCD_API.H"

/*-------------------------------------------------------------------------*
 * File System Routines
 *-------------------------------------------------------------------------*/
#include "FileSys.h"

/*-------------------------------------------------------------------------*
 * Keypad Routines
 *-------------------------------------------------------------------------*/
#include "KeyPad.h"

/*-------------------------------------------------------------------------*
 * Serial Routines
 *-------------------------------------------------------------------------*/
#include "Comm.h"

/*-------------------------------------------------------------------------*
 * Radio Routines
 *-------------------------------------------------------------------------*/
#include "mobitex.h"


/*-------------------------------------------------------------------------*
 *
 * TASK/PROCESS Constants
 *
 *-------------------------------------------------------------------------*/

/* Loader finds "exported" functions */
#define  DLLExport              __declspec (dllexport)
#define  DLLImport              __declspec (dllimport)

void PagerMain(void);
extern char VersionPtr[];
extern int AppStackSize;


#ifdef __cplusplus
};
#endif

#endif  /* __PAGER_H */
