/****************************************************************************
 PredefinedBitmaps.h
 
 Description:
    Common bitmaps that can be used in status and dialog boxes.
 

 Copyright (C) 1997-1999 Research In Motion Limited
 ***************************************************************************/

#ifndef predefinedbitmaps_h_included
#define predefinedbitmaps_h_included

#ifdef DLLAccess
#undef DLLAccess
#endif

#ifdef _UI_
#define DLLAccess DLLExport
#else
#define DLLAccess DLLImport
#endif

#include "warning.h"
#include "Pager.h"

namespace Bitmaps
{
    const int NUM_PREDEFINED_BITMAPS = 4;
}

extern DLLAccess BitMap* BitmapArray[ Bitmaps::NUM_PREDEFINED_BITMAPS ];

namespace Bitmaps
{

    typedef enum
    {
        INFORMATION,
        QUESTION,
        EXCLAMATION,
        HOURGLASS

    } PREDEFINED_BITMAP;

    inline BitMap* PredefinedBitmapToBitmapPtr( PREDEFINED_BITMAP pdb )
    {
        return( BitmapArray[ pdb ] );
    }

} // end of namespace bitmaps



#endif // predefinedbitmaps_h_included
