/****************************************************************************
 PredefinedCharacters.h
 
 Description:
    Constants that refer to characters associated with system fonts.
 

 Copyright (C) 1997-1999 Research In Motion Limited
 ***************************************************************************/

#ifndef predefinedcharacters_h_included
#define predefinedcharacters_h_included

#ifdef DLLAccess
#undef DLLAccess
#endif

#ifdef _UI_
#define DLLAccess DLLExport
#else
#define DLLAccess DLLImport
#endif

#include "warning.h"

namespace Characters
{
    

    const char ALTERNATE_RIGHT_ARROW  = '\x01';              // Was 0x80
    const char ALTERNATE_SPACE        = '\x02';
    const char TX_COMPOSING_ICON      = '\x03';
    const char TX_PENDING_ICON        = '\x04';
    const char TX_SENDING_ICON        = '\x05';
    const char TX_SENT_ICON           = '\x06';
    const char TX_RETURNED_ICON       = '\x07';
    const char TX_MAILBOXED_ICON      = '\x08';

    const char TX_DELIVERED_ICON      = '\x0B';
    const char TX_READ_ICON           = '\x0C';

    const char TX_ERROR_ICON          = '\x0E';
    const char TX_RETRIEVING_KEY_ICON = '\x0F';
    const char TX_COMPRESSING_ICON    = '\x10';
    const char TX_ENCRYPTING_ICON     = '\x11';
    const char TX_ANTENNA_ICON        = '\x12';
    const char RX_UNREAD_ICON         = '\x13';              // Was 0x90
    const char RX_READ_ICON           = '\x14';
    const char RX_READ_ACKED_ICON     = '\x14';
 
    const char RX_ERROR_ICON          = TX_ERROR_ICON;       

    const char UP_ARROW               = '\x16';              // Was 0x96
    const char DOWN_ARROW             = '\x17';
    const char UP_DOWN_ARROW          = '\x18';
    const char ZERO_WIDTH             = '\x19';
    const char ONE_PIXEL_SPACE        = '\x1A';
    const char CHECK_MARK             = '\x1B';
    const char X_MARK                 = '\x1C';


    const char RIGHT_ARROW            = '\x80';
    const char BOX_CHARACTER          = '\x81';              // Was 0xA0

    const char ELLIPSIS               = '\x85';              // Was 0x1F

    const char LEFT_ARROW             = '\x89';

    const char CHECK_BOX_CHARACTER    = '\x8D';              // Was 0xA2
    const char LOW_PRIORITY_ICON      = '\x8E';
    const char REVERSE_RX_UNREAD_ICON = '\x8F';
    const char ALARM_BELL_ICON        = '\x90';

    const char TRADEMARK              = '\x99';              // Was 0xA1

    const char PADLOCK_ICON           = '\x9D';
    const char PRIORITY_ICON          = '\x9E';

    
    } // end of the character namespace
      
#endif