/****************************************************************************
 AddressFieldType.h
 
 Description:
    Defines for the field type codes used within the Address Book.
 
 (C) 1997-1999 Research In Motion Ltd.
 ***************************************************************************/

#ifndef AddressFieldType_H
#define AddressFieldType_H

typedef byte AddressFieldType;

//*****************************************************
// 0: reserved for special case: ANY_FIELD_TYPE
//*****************************************************
#pragma data_seg(".text") 		// put in code space
const AddressFieldType ANY_FIELD_TYPE		=	0;

//*****************************************************
// 1-31: programmatic, communication method fields 
//*****************************************************
const AddressFieldType MIN_COMM_FIELD_TYPE	=	1;
const AddressFieldType MAX_COMM_FIELD_TYPE	=	31;

const AddressFieldType EMAIL				=	1;
const AddressFieldType PHONE				=	2;
const AddressFieldType FAX					=	3;
const AddressFieldType ONE_WAY_PAGE			=	4;	
const AddressFieldType TWO_WAY_PAGE			=	5;	
// add new comm methods here	

//*****************************************************
// 32-63: Programmatic, non-communication method fields
//*****************************************************
const AddressFieldType MIN_PROG_FIELD_TYPE	=	32;
const AddressFieldType MAX_PROG_FIELD_TYPE	=	63;

const AddressFieldType NAME					=	32;
const AddressFieldType COMPANY				=	33;
const AddressFieldType DEFAULT_COMM_METHOD	=	34;		// non-visible field

// add new non-comm methods here

//*****************************************************
// 64-127: user-defined fields
//*****************************************************
const AddressFieldType MIN_USER_FIELD_TYPE	=	64;
const AddressFieldType NOTES				=	64;
const AddressFieldType MAX_USER_FIELD_TYPE	=	127;

//*****************************************************
// 128-254: unused
//*****************************************************

//*****************************************************
// 255: reserved for INVALID_FIELD_TYPE 
//*****************************************************
const AddressFieldType MIN_FIELD_TYPE		=	1;
const AddressFieldType MAX_FIELD_TYPE		=	127;
const AddressFieldType INVALID_FIELD_TYPE   = ((AddressFieldType)0xff);
#pragma data_seg() 		// put in code space

#endif	//AddressFieldType_H
