/*-------------------------------------------------------------------------*
 *
 * Basetype.h
 *
 * Copyright 1997-1998 Research In Motion Limited.  All Rights Reserved
 *-------------------------------------------------------------------------*/

#ifndef __BASE_TYPE_H__
#define __BASE_TYPE_H__

/*
  Define things that also appear in windows.h
*/
typedef unsigned char       BYTE;
typedef signed char         SBYTE;
typedef unsigned short      WORD;
typedef signed short        SWORD;
typedef unsigned long       DWORD;
typedef signed long         SDWORD;
typedef long                LONG;
typedef unsigned int        UINT;

typedef int                 BOOL;
typedef int                 STATUS;

#ifndef TRUE
  #ifdef __cplusplus
    const BOOL              TRUE  = 1;
    const BOOL              FALSE = 0;
  #else
    #define                 TRUE    1
    #define                 FALSE   0
  #endif
#endif

#ifndef NULL
  #ifdef __cplusplus
    #define NULL 0
  #else
    #define NULL ((void *) 0)
  #endif
#endif

typedef DWORD               TASK;

typedef void                (*FUNCTION)();


// The following structure is defined here because it is needed
// in both the LCD and the process management subsystems.
#if _MSC_VER >= 1000
#pragma pack(push,2)
    typedef struct
    {
        BYTE    bType; // 0 = monochrome.
        WORD    wide, high;
        BYTE    *data;
    } BitMap;
#pragma pack(pop)
#endif

#endif
