/****************************************************************************
 Config.h
 
 Description:
     Prototypes for functions that change/check configurations.  This is used
     internally by the UI Engine.

 Copyright (C) 1997-1999 Research In Motion Limited
 ***************************************************************************/

#ifndef config_h_included
#define config_h_included
#include "warning.h"
#include "pager.h"

#ifdef DLLAccess
#undef DLLAccess
#endif

#ifdef _UI_
#define DLLAccess DLLExport
#else
#define DLLAccess DLLImport
#endif


void DLLAccess SetLineMode( int NumberOfLines );

namespace UIConfig
{
    typedef enum 
    {
        TEN_PIXEL_FONT,
        EIGHT_PIXEL_FONT

    }FONTSIZES;


    void SetFontSize( FONTSIZES newFontSizes );

    FONTSIZES GetFontSize();

    int GetLCDParameters(); // returns a number representing all the characteristics
                            // of the screen, if this number is different, all data
                            // that depends on dimensions must be recalculated
    
        
    void IncrementTaskListVersion(); // increments a version number so that
                                     // menus can tell if they have current data 
                                     // or not
    int GetTaskListVersion();       
    
}
#endif // config_h_included
