/****************************************************************************
 Msg_API.h   
 
 Description:
    This file describes the API that allows developers to use the RIM messaging
    application from within their own programs.  Sample code is provided with
    the Inter@ctive Pager 950 SDK that uses this API.
      
 Copyright (C) 1997-1999 Research In Motion Limited
 ***************************************************************************/

#ifndef MSG_API_H
#define MSG_API_H

              
#include "message.h"
#include "AddressFieldType.h"
#include "database.h"

#ifdef DLLAccess
#undef DLLAccess
#endif
#ifdef _MESSAGE_
#define DLLAccess DLLExport
#else 
#define DLLAccess DLLImport
#endif


/*
 * Message API
 */

extern "C" DLLAccess
int
delete_stale_messages( int desired_free_space = 20000 );


extern "C" DLLAccess
bool
is_composing_message( void );


extern "C" DLLAccess
bool
create_message( NetworkMessage * message = NULL );


extern "C" DLLAccess
DbFieldHandle
add_recipient( DbFieldTag field_tag,        // TO_FIELD_TAG, CC_FIELD_TAG, BCC_FIELD_TAG
               AddressFieldType address_type,
               char * address,
               char * name = "" );


extern "C" DLLAccess
DbFieldHandle
add_field_text( DbFieldTag field_tag,       // SUBJECT_TAG, MESSAGE_TAG            
                char * text,                // multiple calls are concatenated
                int length = DB_TEXT );


extern "C" DLLAccess
void
delete_field( DbFieldHandle field_handle );

      
extern "C" DLLAccess
bool 
send_message( bool prompt_user_flag );


extern "C" DLLAccess
void
abort_message( void );


#endif