/****************************************************************************
 PredefinedSounds.h
 
 Description:
    Common sounds to be associated with actions.
 

 Copyright (C) 1997-1998 Research In Motion Limited
 ***************************************************************************/

#ifndef predefinedsounds_h_included
#define predefinedsounds_h_included

#include "warning.h"
#include "pager.h"

namespace Sounds
{
    

    typedef enum
    {
        INPUT_ERROR
    } PREDEFINED_SOUNDS;

    typedef struct
    {
        int Frequency;
        int Duration;
        int DutyCycle;
        int Volume;
    } SoundCharacteristics;

    SoundCharacteristics const SoundArray[ 1 ] 
        = {
            {500,100,10,50 } // 500hz for 1 second at 10% duty and 50% intensity 
          };
            

    inline void DoSound( PREDEFINED_SOUNDS pds )
    {
        SoundCharacteristics SoundtoDo = SoundArray[pds];

        RimSpeakerBeep( SoundtoDo.Frequency, SoundtoDo.Duration, SoundtoDo.DutyCycle, 
                        SoundtoDo.Volume );
        return;
    }

} // end of namespace bitmaps

#endif // predefinedbitmaps_h_included
