/****************************************************************************
 Services.h
 
 Description:
    This file contains various utility functions used by the UI Engine. 

 Copyright (C) 1997-1999 Research In Motion Limited
 ***************************************************************************/

#ifndef services_h_included
#define services_h_included

#include "warning.h"
#include "pager.h"

#include "limits.h"
#include "helper.h"


#ifdef DLLAccess
#undef DLLAccess
#endif

#ifdef _UI_
#define DLLAccess DLLExport
#else
#define DLLAccess DLLImport
#endif


namespace Services
{
	DLLAccess void Initialize();

    DLLAccess int GetFontHeight() ;
	DLLAccess int GetCharacterWidth( char const Character );
	DLLAccess char GetAltedChar( char Char );

    DLLAccess void FindWrapPoint( char const * const pBuffer, int &ResultLength, 
                                  int &ResultWidth, int const MaxWidth=LCD_WIDTH,
                                  int const MaxLength=INT_MAX );
	DLLAccess int FindWidth( char const * const pBuffer, int const Length=INT_MAX );
	DLLAccess int FindWidthtoOffset( char const * const pBuffer, int const Offset );
	DLLAccess int FindOffsetfromWidth( char const * const pData, int const Length, 
                                       int const Width );
    DLLAccess int ReplaceFont( int iFontIndex, 
                                         const FontDefinition *pNewFont );
    
};
      
#endif