//
// Copyright (C) 1999, 2000 Lyle Coder (x_coder@hotmail.com)
//

#include <stdio.h>
#include <string.h>
#include "Tag.h"

void Tag::addAttribute(char *name, char *param)
{
	Attribute *a = new Attribute(name, param);
	attrib = a->addSibling(attrib);
}

//
// Data is always in string format. Appends data to any existing data charecters.
// OK to delete data (parameter) after invocation.
// XXX Optimize
//
void Tag::addData(char *d, int len)
{
	if(dataChild) {
		char *tmp = new char[len + strlen(dataChild->data) + 1];
		memset(tmp, 0, len + strlen(dataChild->data) + 1);
		strcpy(tmp, dataChild->data);
		strncat(tmp, d, len);
		delete [] dataChild->data;
		dataChild->data = new char[strlen(tmp) + strlen(dataChild->data) + 1];
		strcpy(dataChild->data, tmp);
		delete [] tmp;
	} else {
		dataChild = new Tag(this);
		dataChild->data = new char[len + 1];
		memset(dataChild->data, 0, len + 1);
		strncpy(dataChild->data, d, len);
		dataChild = addChild(dataChild);
	}
}

//
// Add a child node... if a child node exists, the tag is added as a sibling of the child node.
// Do not delete tag (input parameter) after calling this method... the pointer is retained
//
Tag *Tag::addChild(Tag *tag)
{
	dataChild = 0;
	tag->parent = this;
	if(child) {
		return child->addSibling(tag);
	} else {
		child = tag;
		return child;
	}
}

//
// Returns the parent tag
//
Tag *Tag::endTag(void)
{
	return parent;
}

//
// Add a sibling node.  If sibling exists, it is inserted at the head of the linked list.
// Do not delete tag (parameter) after calling because the pointer is retained.  
// Parameter tag is considered to be an unrelated node... ie, it cannot have any child and sibling nodes
//
Tag *Tag::addSibling(Tag *tag)
{
	if(!sibling) {
		siblingTail = sibling = tag;
	} else {
		siblingTail->sibling = tag;
		siblingTail = tag;
	}
	return tag;
}
