//
// Copyright (C) 1999, 2000 Lyle Coder (x_coder@hotmail.com)
//

#ifndef _TAGFIELD_H_
#define _TAGFIELD_H_

#include "UI32.h"
#include "Tag.h"
#include "WAP.h"

class TagField : public Edit
{
public:
	TagField(BrowserScreen *browser, Tag *tag, char * const pnewBuffer, int const newLengthofBuffer, int const newCharacterOffset, int const justify) : Edit(" ", pnewBuffer, newLengthofBuffer, newCharacterOffset, justify)
	{
		if((*(tag->name) == 'a') || (*(tag->name) == 'A')) {
			SetLabel(">");
			isLink = true;
		} else {
			isLink = false;
		}
		this->tag = tag;
		this->browser = browser;
	}

	void TakeFocus()
	{
		Edit::TakeFocus();
		browser->setActiveTag(0);
	}

	bool GiveFocus(int const directionMagnitude)
	{
		bool result = Edit::GiveFocus(directionMagnitude);
		// SetCursorOffset(0);
		if(!directionMagnitude && isLink) {
			browser->setActiveTag(tag);
		}
		return result;
	}

private:
	bool isLink;
	class Tag *tag;
	BrowserScreen *browser;
};

#endif