// 
// Copyright  2000 Chris Faherty <rallymonkey@bellsouth.net>
// Lots and lots of code copied from:
// RIM SDK samples
//

#ifndef _MESSAGE_H_
#define _MESSAGE_H_

#include "int_message.h"
#include "database.h"

class Message : public NetworkMessage {
private:
    DbFieldHandle temph;
    
public:
    /* read only constructor */
    Message(DbRecordHandle db_record_handle) :
        NetworkMessage(db_record_handle) {}

    /* read/write constructor */
    Message(DbRecordHandle db_record_handle,
        NetworkMessageData * data_ptr) :
        NetworkMessage(db_record_handle, data_ptr ) {}

    int get_from(char **from)
    {
        DbFieldHandle desc_handle = get_first_field_handle(FROM_FIELD_TAG);
        if (desc_handle == DB_INVALID_FIELD_HANDLE) {
            *from = NULL;
            return 0;
        } else {
            *from = (char *) get_address(desc_handle);
        }
        return strlen(*from);
    }
    int get_sender(char **sender)
    {
        DbFieldHandle desc_handle = get_first_field_handle(SENDER_FIELD_TAG);
        if (desc_handle == DB_INVALID_FIELD_HANDLE) {
            *sender = NULL;
            return 0;
        } else {
            *sender = (char *) get_address(desc_handle);
        }
        return strlen(*sender);
    }
    int get_first_to(char **to)
    {
        DbFieldHandle desc_handle = get_first_field_handle(TO_FIELD_TAG);
        temph = desc_handle;
        if (desc_handle == DB_INVALID_FIELD_HANDLE) {
            *to = NULL;
            return 0;
        } else {
            *to = (char *) get_address(desc_handle);
        }
        return strlen(*to);
    }
    int get_next_to(char **to)
    {
        DbFieldHandle desc_handle = get_next_field_handle(temph, TO_FIELD_TAG);
        temph = desc_handle;
        if (desc_handle == DB_INVALID_FIELD_HANDLE) {
            *to = NULL;
            return 0;
        } else {
            *to = (char *) get_address(desc_handle);
        }
        return strlen(*to);
    }
    int get_first_cc(char **cc)
    {
        DbFieldHandle desc_handle = get_first_field_handle(CC_FIELD_TAG);
        temph = desc_handle;
        if (desc_handle == DB_INVALID_FIELD_HANDLE) {
            *cc = NULL;
            return 0;
        } else {
            *cc = (char *) get_address(desc_handle);
        }
        return strlen(*cc);
    }
    int get_next_cc(char **cc)
    {
        DbFieldHandle desc_handle = get_next_field_handle(temph, CC_FIELD_TAG);
        temph = desc_handle;
        if (desc_handle == DB_INVALID_FIELD_HANDLE) {
            *cc = NULL;
            return 0;
        } else {
            *cc = (char *) get_address(desc_handle);
        }
        return strlen(*cc);
    }
    int get_subject(char **subject)
    {
        DbFieldHandle desc_handle = get_first_field_handle(SUBJECT_FIELD_TAG);
        if (desc_handle == DB_INVALID_FIELD_HANDLE) {
            *subject = NULL;
            return 0;
        } else {
            *subject = (char *) get_field_data_ptr(desc_handle);
        }
        return get_field_data_length(desc_handle);
    }
    int get_body(char **body)
    {
        DbFieldHandle desc_handle = get_first_field_handle(MESSAGE_FIELD_TAG);
        if (desc_handle == DB_INVALID_FIELD_HANDLE) {
            *body = NULL;
            return 0;
        } else {
            *body = (char *) get_field_data_ptr(desc_handle);
        }
        return get_field_data_length(desc_handle);
    }
};

#endif
